@ECHO OFF

REM Parse input, find modulation to parent
snmputil walk %1 %2 .1.3.6.1.4.1.15319.2.2.1.3 > 1.txt
type 1.txt | grep -B 1 "Integer32 10" | grep "Variable" > 2.txt
for /f "tokens=1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16 delims=." %%a in (2.txt) do set nodeid=%%m

snmputil get %1 %2 .1.3.6.1.4.1.15319.3.2.1.21.%nodeid% | grep "Value" > 3.txt
for /f "tokens=1,2,3,4 delims= " %%a in (3.txt) do set RedDrops=%%d

snmputil get %1 %2 .1.3.6.1.4.1.15319.3.2.1.20.%nodeid% | grep "Value" > 4.txt
for /f "tokens=1,2,3,4 delims= " %%a in (4.txt) do set QueueDrops=%%d

snmputil get %1 %2 .1.3.6.1.4.1.15319.3.2.1.19.%nodeid% | grep "Value" > 5.txt
for /f "tokens=1,2,3,4 delims= " %%a in (5.txt) do set RxMissed=%%d

snmputil get %1 %2 .1.3.6.1.4.1.15319.3.2.1.18.%nodeid% | grep "Value" > 6.txt
for /f "tokens=1,2,3,4 delims= " %%a in (6.txt) do set RxDuplicate=%%d

snmputil get %1 %2 .1.3.6.1.4.1.15319.3.2.1.14.%nodeid% | grep "Value" > 7.txt
for /f "tokens=1,2,3,4 delims= " %%a in (7.txt) do set TxRetries=%%d

snmputil get %1 %2 .1.3.6.1.4.1.15319.3.2.1.15.%nodeid% | grep "Value" > 8.txt
for /f "tokens=1,2,3,4 delims= " %%a in (8.txt) do set TxRLimit=%%d

snmputil get %1 %2 .1.3.6.1.4.1.15319.3.2.1.8.%nodeid% | grep "Value" > 9.txt
for /f "tokens=1,2,3,4 delims= " %%a in (9.txt) do set RxFrames=%%d

snmputil get %1 %2 .1.3.6.1.4.1.15319.3.2.1.9.%nodeid% | grep "Value" > 10.txt
for /f "tokens=1,2,3,4 delims= " %%a in (10.txt) do set TxFrames=%%d


REM CleanUp
DEL 1.txt
DEL 2.txt
DEL 3.txt
DEL 4.txt
DEL 5.txt
DEL 6.txt
DEL 7.txt
DEL 8.txt
DEL 9.txt
DEL 10.txt

REM Show results, set returncode and exit
ECHO.
ECHO Received Frames: %RxFrames%
ECHO Transmitted Frames: %TxFrames%
ECHO.
ECHO Red Drops: %RedDrops%
ECHO Queue Drops: %QueueDrops%
ECHO Missed Receives: %RxMissed%
ECHO Duplicate Receives: %RxDuplicate%
ECHO Transmit Retries: %TxRetries%
ECHO Transmit Retry Limit: %TXRLimit%

REM Updating RRD Database
rrdtool update %1.rrd N:%TXFRAMES%:%RXFRAMES%:%RedDrops%:%QUEUEDROPS%:%RXMISSED%:%RXDuplicate%:%TXRETRIES%:%TXRLimit%
rrdtool graph %1.png -s -3600 --width=800 --height=400 --imgformat PNG --title="%1 Link Stats Info" -E DEF:REDD=%1.rrd:REDD:LAST LINE1:REDD#FF0000:"Red Drops\:" VDEF:REDDV=REDD,LAST GPRINT:REDDV:"%%lg" DEF:QD=%1.rrd:QUEUED:LAST LINE1:QD#0000FF:"Queue Drops\:" VDEF:QUEUEDV=QD,LAST GPRINT:QUEUEDV:"%%lg\l" DEF:RXM=%1.rrd:RXMISSED:LAST LINE1:RXM#00FF00:"Receives Missed\:" VDEF:RXMV=RXM,LAST GPRINT:RXMV:"%%lg" DEF:RXD=%1.rrd:DUPRX:LAST LINE1:RXD#00FFFF:"Duplicate Receives\:" VDEF:RXDV=RXD,LAST GPRINT:RXDV:"%%lg\l" DEF:TXR=%1.rrd:TXRETRIES:LAST LINE1:TXR#777777:"Transmit Retries\:" VDEF:TXRV=TXR,LAST GPRINT:TXRV:"%%lg" DEF:TXL=%1.rrd:TXRETRYL:LAST LINE1:TXL#DDAA00:"Transmit Retry Limit\:" VDEF:TXLV=TXL,LAST GPRINT:TXLV:"%%lg\l"

REM DEF:TXF=%1.rrd:TXFRAME:LAST LINE1:TXF#0000FF:"Transmitted Frames" DEF:RXF=%1.rrd:RXFRAME:LAST LINE1:RXF#00FF00:"Received Frames"
